//<c>   Copyright 1984-2000 by Gerry J. Danen; all rights reserved.

//<t>   Empty Files Selectively

#include"gd_tools.h"
#include"gd_extrn.h"
#include"gd_files.h"
#include"gd_mouse.h"
#include"gd_kb.h"
#include<errno.h>


#if     (! LARGE_MODEL)
  #error LARGE MEMORY MODEL REQUIRED
#endif


#define pgVERS_ "V4.20"
#define pgTITL_ "Selective File Emptying"
#define pgCOPR_ "1984"


#define         DIR_MAX 700                     // maximum dir. entries
extern  INT16   marked_entries  ;               // # of marked entries
extern  INT16   max_entries  ;                  // maximum # of entries


BOOL    EmptyFile( STRING filespec )
{
    int fh ;

    fh = _unlink( filespec );
    if ( fh == -1 && errno == EACCES )
    {
        return( ERROR );                // directory or read-only
    }
    else
    {
        fh = _open( filespec, (O_CREAT|O_BINARY), (S_IREAD|S_IWRITE) );
        if ( fh == -1 && errno == EMFILE )
        {
            return( ERROR );            // too many open files
        }
        else
        {
            _close( fh );
            return( OK );
        }
    }
}


void    main( int argc, char *argv[] )
{
    SUBDIR      hDir ;                          // directory header
    DIRLIST     *eDir[ DIR_MAX + 1 ] ;          // directory entries
    UCHAR       filespec[FS_LEN] ;              // file specification
    UCHAR       stuff   [51] ;                  // work string
    UCHAR       *mark_msg = "Select files to empty:" ;
    INT16       i, ch, ercode, ok_to_empty ;

    fs_init( FALSE, SHAREWARE_VERSION, 0, pgVERS_, pgTITL_, pgCOPR_ );
    Allow_Break();                              // allow ^Break to abort
    ms_init();

    tty_print( "\nWait\r" );
    if ( DIR_init( DIR_MAX, &hDir, eDir ) != OK )
    {
        tty_print( "\nOnly enough memory for %d files\a\n", max_entries );
    }
    if ( argc == 1 )
        st_cpy( filespec, "*.*", FS_LEN );
    else
        st_cpy( filespec, argv[1], FS_LEN );
    ercode = DIR_find( &hDir, eDir, filespec, REGULAR_FILES );
    DIR_show( &hDir, eDir, mark_msg, ercode, 2 );
    NewScreen();
    if ( marked_entries )
    {
        tty_print( "\a\nEmptying " );
        if ( marked_entries == hDir.entries )
            tty_print( "ALL SELECTED" );
        else
            tty_print( "%d of %d", marked_entries, hDir.entries );
        tty_print( " files from %s\n", hDir.path );
        CursOn();
        if ( marked_entries > 1 )
        {
            tty_print( "Please confirm.\nOK to empty %d files (Y/N)? ", marked_entries );
            do
            {
                ch = kb_getkey_();
            }   while ( StrFindChar( (UCHAR) ch, "YyNn" ) < 0 );
            tty_print( "%c\n", (UCHAR) ch );
            if ( StrFindChar( (UCHAR) ch, "Yy" ) < 0 )
                goto main_eoj ;
        }
        LOOP( i, 1, hDir.entries, 1 )
        {
            if ( eDir[i]->marked )
            {
                ok_to_empty = FALSE ;
                eDir[i]->marked = (FLAG) (! eDir[i]->marked) ;
                DIR_format_entry( &hDir, eDir, i, filespec, NO );
                st_trim( filespec );
                st_cpy ( stuff, filespec, 45 );
                tty_print( "\n%s ... ", stuff );
                sprintf( filespec, "%s%s.%s", hDir.path, eDir[i]->name, eDir[i]->ext );
                if ( eDir[i]->at_sub_dir )
                    {}
                else
                if ( eDir[i]->at_read_only )
                {
                    tty_printf( vid.err_fg, vid.err_bg, " read-only file " );
                    tty_print( "\n\t\t      Empty this file? " );
                    CursOn();
                    do  {
                        ch = kb_getkey_();
                    }   while ( StrFindChar( (UCHAR) ch, "YyNn" ) < 0 );
                    CursOff();
                    if ( StrFindChar( (UCHAR) ch, "Yy" ) < 0 )
                    {
                        tty_print( "No   " );
                    }
                    else
                    {
                        tty_printf( vid.err_fg, vid.err_bg, " Yes " );
                        SetAttrib( filespec, -1, 0, 0, 0 );
                        ok_to_empty = TRUE ;
                    }
                    tty_print( " ... " );
                }
                else
                {
                    ok_to_empty = TRUE ;
                }
                if ( ok_to_empty )
                {
                    if ( (ercode = EmptyFile( filespec )) == OK )
                        tty_print( "emptied" );
                    else
                        tty_printf( vid.err_fg, vid.err_bg, " error \a" );
                }
                else
                {
                    if ( ! eDir[i]->at_sub_dir )
                        tty_print( "not emptied" );
                }
            }
        }
    }
    else
        tty_print( "\nNothing to do" );

main_eoj:
    tty_print( "\n" );

    DIR_exit( eDir );

    gd_exit( 0, "" );
}
